/*
*坦克類
*/ 

var Tank=function(){
	this.width=this.height=BASE*2;	//寬、高
	this.dir;		//方向：1-上、2-下、3-左、4-右
	this.speed=BASE/4;	//速度
	this.type;	//坦克種類：1、2、3
	this.basePos=null;	//不同種類的坦克背景圖片顯示的基本位置（坦克材料對象）
	this.index=0;	//坦克研發效果次數統計，6次以後便創造出來
	this.tankDiv=null;	//坦克對象
}

//移动
Tank.prototype.move=function(){
	var maxVal=(this.dir==1 || this.dir==3)?0:BASE*24;	//方向：上題0，下右圖24*16
	var attr=(this.dir==1 || this.dir==2)?"top":"left";	//方向：操作對上操作，左右對左
	var attrVal=parseInt(getAttr(this.tankDiv,attr));		//獲取當前方向上的價值
	
	var speed=(this.dir==1||this.dir==3)?-1*this.speed:this.speed;//方向：上、右 速度為負
	var isGo={ result:true };
	
	//檢測是否發生碰撞
	isGo=isHit(this.tankDiv, speed, attr); 
	
	if(attrVal!=maxVal && isGo.result){		
		this.tankDiv.style[attr]=attrVal+speed+'px';
		return;
	}
	
	if(this.tankDiv.category===ENEMY) {
		//如果不是FLOW或者不是自己的一夥，則無法繼續，改變方向
		this.setDir();
	}
}

//改變方向
Tank.prototype.setDir=function(dir){
	this.dir=dir?dir:getRandom(1,4);
	this.tankDiv.style.backgroundPosition=(this.basePos.x-32*(this.dir-1))+"px "+this.basePos.y+"px";
}

//創建子彈的後綴：id的後綴
Tank.prototype.createBullet=function(bulletCategory,suffixID){
	//var oBullet=new Bullet();
	var bullet=createDiv(BULLET,0,0,suffixID);
	bullet.category=bulletCategory;
	oMoveBox.appendChild(bullet);
	return bullet;
}

//直接的目標方法
Tank.prototype.shoot=function(bulletCategory){
	if(!TankObj[this.tankDiv.id]) return;	//如果該坦克射擊了子彈，則不要繼續出
	var oBullet=this.createBullet(bulletCategory,this.tankDiv.id);
	
	var x=parseInt(getAttr(this.tankDiv, "left"));
	var y=parseInt(getAttr(this.tankDiv, "top"));
	switch(this.dir){
		case 1:x+=13,y-=6;
			break;
		case 2:x+=13,y+=32;
			break;
		case 3:x-=6,y+=13;
			break;
		case 4:x+=32,y+=13;
			break;
	}
	oBullet.style.left=x+"px";
	oBullet.style.top=y+"px";
	oBullet.id="div_"+x+"_"+y+'_'+this.tankDiv.id;
	//TankObj[this.tankDiv.id].oBullet=oBullet;
	TankObj[this.tankDiv.id].bulletID=oBullet.id;
	
	var baseObj={};
	baseObj.dir=this.dir;
	baseObj.speed=2*this.speed;
	baseObj.bullet=oBullet;
	BulletMove(baseObj);
	oBullet.bulletTimer=setInterval(function(){BulletMove(baseObj)},30);
}


//移動
function BulletMove(baseObj){
	//if(!this.bullet) return;
	var attr=(baseObj.dir==1 || baseObj.dir==2)?"top":"left";	// top left
	var attrVal=parseInt(getAttr(baseObj.bullet,attr));	//獲取當前方向上的價值
	var isOverMaxVal=(baseObj.dir==1||baseObj.dir==3)?attrVal<=0:attrVal>=(BASE*26-6);	// 方向：左下圖標返回0，下右大於上則返回true26*16		
	var speed=(baseObj.dir==1||baseObj.dir==3)?-1*baseObj.speed:baseObj.speed;//方向：上、右 速度為負
	
	//檢測是否發生碰撞
	var isGo={ result:true };	
	isGo=isHit(baseObj.bullet, speed, attr); 
	
	//是否到達
	if(isOverMaxVal){
		BulletDie(baseObj.bullet);
		return;
	}
	
	if(isGo.result){		
		baseObj.bullet.style[attr]=attrVal+speed+'px';
		return;
	}
	
	//虛假的拒絕
	if(!isGo.result){
		var eleDiv=document.getElementById(isGo.eleID),
			eleClass=eleDiv.className,
			eleCategory=eleDiv.category,
			bulletCategory=baseObj.bullet.category;
			
		if(eleClass==SLAB){
			//是片斷-Slab，則亡
			BulletDie(baseObj.bullet);
		}
		else if(eleClass==WALL){
			oGrid[isGo.iGrid].splice(isGo.index,1);	
			BulletKill(eleDiv);
		}
		else if(eleClass==TANK && bulletCategory!=eleCategory){
			BulletKill(eleDiv);
		}
		else if(eleClass==BULLET && bulletCategory!=eleCategory){
			BulletDie(baseObj.bullet);
			BulletDie(eleDiv);
		}
		else{
			baseObj.bullet.style[attr]=attrVal+speed+'px';
		}
	}
	
		
	//子彈消失
	function BulletDie(bulletDiv){
		var Tank=getTankObjByBulletID(bulletDiv.id);
		if(!Tank || !bulletDiv || !bulletDiv.parentNode) return;
		
		clearInterval(bulletDiv.bulletTimer);
		try{
			oMoveBox.removeChild(bulletDiv);
		}catch(ex){ 
			return;
		}
		bulletDiv=null;
		
		if(Tank.oTank && Tank.oTank.tankDiv.category===ENEMY){
			//炸彈消失，坦克隔800毫秒後繼續發射
			setTimeout(function(){
				if(!Tank.oTank) return;
				Tank.oTank.shoot(Tank.oTank.tankDiv.category);
			},1000);
		}
		
	}
	
	//消滅對方
	function BulletKill(killObj){
		BulletDie(baseObj.bullet);
		
		var className=killObj.className;
		//如果對方是坦克
		if(className===TANK) {
			var Tank=getTankObjByTankID(killObj.id);
			if(!Tank) return;
			//消滅後新增坦克
			if(killObj.category===MYTANK){
				--Global.myTank.nowCount<0 && (Global.myTank.nowCount=0);
				Global.myTank.createMyTank();
			}else{
				clearInterval(Tank.oTank.tankMoveTimer);
				clearTimeout(Tank.oTank.shootTimer);
				Tank.oTank=Tank[Tank.oTank.tankID]=null;
				--Global.enemyTank.nowCount<0 && (Global.enemyTank.nowCount=0);
				Global.enemyTank.createEnemy();
			}
			oMoveBox.removeChild(killObj);
		}else if(className===BULLET){
			//var Tank=getTankObjByBulletID(killObj.id);
			//if(!Tank.oBullet) return;
			BulletDie(baseObj.bullet);
			console.log("87");
		}
		else{
			oBox.removeChild(killObj);
			console.log("987");
		}
		killObj=null;
		
	}
	 
	
}
